/*************************************************************

  ce_extend.m
  by pjn123 (v1.00)
  28 September 2008
  www.SkinConsortium.com

  - this script enables you to move the sliders together if you press Ctrl or Shift (Only on RGB mode)

*************************************************************/

#include <lib/std.mi>
#include <lib/application.mi>

Function int calc_gamma(int source, int required);
Function updateColor();

Function String calc_color_string(String type);
Function int calc_color_int(String type);

Global Group myGroup;
Global Slider r_slider, g_slider, b_slider;
Global boolean key_shift = false;
Global boolean md_r, md_g, md_b;
Global int r_pos, g_pos, b_pos;
Global checkbox rgbmode, hslmode;
Global Button openSavedFolder, faqButton;

Global Edit sourceRed, sourceGreen, sourceBlue;
Global Edit reqRed, reqGreen, reqBlue;
Global GuiObject reqColor, genColor;
Global Button genSliders, rgbButton, applyChanges;

System.onScriptLoaded() {
	myGroup = getScriptGroup();
	r_slider = myGroup.findObject("coloreditor.slider.red");
	g_slider = myGroup.findObject("coloreditor.slider.green");
	b_slider = myGroup.findObject("coloreditor.slider.blue");
	rgbmode = myGroup.findObject("coloreditor.checkbox.rgb");
	hslmode = myGroup.findObject("coloreditor.checkbox.hsl");
	openSavedFolder = myGroup.findObject("coloreditor.button.folder");
	faqButton = myGroup.findObject("coloreditor.button.faq");

	sourceRed = myGroup.findObject("coloredit.source.red");
	sourceGreen = myGroup.findObject("coloredit.source.green");
	sourceBlue = myGroup.findObject("coloredit.source.blue");

	reqRed = myGroup.findObject("coloredit.source.red.req");
	reqGreen = myGroup.findObject("coloredit.source.green.req");
	reqBlue = myGroup.findObject("coloredit.source.blue.req");

	reqColor = myGroup.findObject("coloredit.source.rect.req");
	genColor = myGroup.findObject("coloredit.source.rect.gen");

	genSliders = myGroup.findObject("coloreditor.gen");
	rgbButton =  rgbmode.findObject("checkbox.toggle");
	applyChanges = myGroup.findObject("coloreditor.apply");

	reqRed.setText(integerToString(System.getPublicInt("color.editor.req.red", 200)));
	reqGreen.setText(integerToString(System.getPublicInt("color.editor.req.green", 200)));
	reqBlue.setText(integerToString(System.getPublicInt("color.editor.req.blue", 200)));
	reqColor.setXmlParam("color", integerToString(System.getPublicInt("color.editor.req.red", 200))+","+integerToString(System.getPublicInt("color.editor.req.green", 200))+","+integerToString(System.getPublicInt("color.editor.req.blue", 200)));

	md_r=false;
	md_g=false;
	md_b=false;
}

r_slider.onSetPosition(int newpos){
	if(md_r && !hslmode.isChecked()){
		if(isKeyDown(VK_CONTROL)){
			if(g_slider.getPosition()!=newpos) g_slider.setPosition(newpos);
			if(b_slider.getPosition()!=newpos) b_slider.setPosition(newpos);
		}
		else if(isKeyDown(VK_SHIFT)){
			if(g_slider.getPosition()!=newpos-(r_pos-g_pos)) g_slider.setPosition(newpos-(r_pos-g_pos));
			if(b_slider.getPosition()!=newpos-(r_pos-b_pos)) b_slider.setPosition(newpos-(r_pos-b_pos));
		}
	}
}

g_slider.onSetPosition(int newpos){
	if(md_g && !hslmode.isChecked()){
		if(isKeyDown(VK_CONTROL)){
			if(r_slider.getPosition()!=newpos) r_slider.setPosition(newpos);
			if(b_slider.getPosition()!=newpos) b_slider.setPosition(newpos);
		}
		else if(isKeyDown(VK_SHIFT)){
			if(r_slider.getPosition()!=newpos-(g_pos-r_pos)) r_slider.setPosition(newpos-(g_pos-r_pos));
			if(b_slider.getPosition()!=newpos-(g_pos-b_pos)) b_slider.setPosition(newpos-(g_pos-b_pos));
		}
	}
}

b_slider.onSetPosition(int newpos){
	if(md_b && !hslmode.isChecked()){
		if(isKeyDown(VK_CONTROL)){
			if(r_slider.getPosition()!=newpos) r_slider.setPosition(newpos);
			if(g_slider.getPosition()!=newpos) g_slider.setPosition(newpos);
		}
		else if(isKeyDown(VK_SHIFT)){
			if(r_slider.getPosition()!=newpos-(b_pos-r_pos)) r_slider.setPosition(newpos-(b_pos-r_pos));
			if(g_slider.getPosition()!=newpos-(b_pos-g_pos)) g_slider.setPosition(newpos-(b_pos-g_pos));
		}
	}
}

System.onKeyDown(String key){
	if(key=="shift"){
		if(!key_shift){
			r_pos = r_slider.getPosition();
			g_pos = g_slider.getPosition();
			b_pos = b_slider.getPosition();
			key_shift=true;
		}
	}
	else key_shift=false;
}

r_slider.onLeftButtonDown(int x, int y){md_r=true;}
r_slider.onLeftButtonUp(int x, int y){md_r=false;}

g_slider.onLeftButtonDown(int x, int y){md_g=true;}
g_slider.onLeftButtonUp(int x, int y){md_g=false;}

b_slider.onLeftButtonDown(int x, int y){md_b=true;}
b_slider.onLeftButtonUp(int x, int y){md_b=false;}

openSavedFolder.onLeftClick(){
	System.navigateUrl(Application.GetSettingsPath()+"\Plugins\Freeform\wacs\coloreditor\data");
}

faqButton.onLeftClick(){
	System.navigateUrl("http://forums.winamp.com/showthread.php?t=161484");
}

sourceRed.onEditUpdate(){
	updateColor();
}

sourceGreen.onEditUpdate(){
	updateColor();
}

sourceBlue.onEditUpdate(){
	updateColor();
}

reqRed.onEditUpdate(){
	int mycolor = stringToInteger(reqRed.getText());
	if(mycolor>255) mycolor = 255;
	else if (mycolor<0) mycolor = 0;

	System.setPublicInt("color.editor.req.red", mycolor);
	if(stringToInteger(reqRed.getText()) != mycolor) reqRed.setText(integerToString(mycolor));
	//reqRed.setText(integerToString(mycolor));

	reqColor.setXmlParam("color", integerToString(System.getPublicInt("color.editor.req.red", 200))+","+integerToString(System.getPublicInt("color.editor.req.green", 200))+","+integerToString(System.getPublicInt("color.editor.req.blue", 200)));
	updateColor();
}

reqGreen.onEditUpdate(){
	int mycolor = stringToInteger(reqGreen.getText());
	if(mycolor>255) mycolor = 255;
	else if (mycolor<0) mycolor = 0;

	System.setPublicInt("color.editor.req.green", mycolor);
	if(stringToInteger(reqGreen.getText()) != mycolor) reqGreen.setText(integerToString(mycolor));
	//reqGreen.setText(integerToString(mycolor));

	reqColor.setXmlParam("color", integerToString(System.getPublicInt("color.editor.req.red", 200))+","+integerToString(System.getPublicInt("color.editor.req.green", 200))+","+integerToString(System.getPublicInt("color.editor.req.blue", 200)));
	updateColor();
}

reqBlue.onEditUpdate(){
	int mycolor = stringToInteger(reqBlue.getText());
	if(mycolor>255) mycolor = 255;
	else if (mycolor<0) mycolor = 0;

	System.setPublicInt("color.editor.req.blue", mycolor);
	if(stringToInteger(reqBlue.getText()) != mycolor) reqBlue.setText(integerToString(mycolor));
	//reqBlue.setText(integerToString(mycolor));

	reqColor.setXmlParam("color", integerToString(System.getPublicInt("color.editor.req.red", 200))+","+integerToString(System.getPublicInt("color.editor.req.green", 200))+","+integerToString(System.getPublicInt("color.editor.req.blue", 200)));
	updateColor();
}

int calc_gamma(int source, int required){
	if(source==0) return 0;

	int c = -((1-(required/source))*4096);
	if(c>4096) c = 4096;
	else if(c<-4096) c = -4096;

	return c;
}

int calc_color_int(String type){
	int calc;

	if(type=="RED"){
		calc = calc_gamma(stringToInteger(sourceRed.getText()), stringToInteger(reqRed.getText()));
		calc = stringToInteger(sourceRed.getText()) + (stringToInteger(sourceRed.getText()) / 4096 * calc);
	}
	else if(type=="GREEN"){
		calc = calc_gamma(stringToInteger(sourceGreen.getText()), stringToInteger(reqGreen.getText()));
		calc = stringToInteger(sourceGreen.getText()) + (stringToInteger(sourceGreen.getText()) / 4096 * calc);
	}
	else if(type=="BLUE"){
		calc = calc_gamma(stringToInteger(sourceBlue.getText()), stringToInteger(reqBlue.getText()));
		calc = stringToInteger(sourceBlue.getText()) + (stringToInteger(sourceBlue.getText()) / 4096 * calc);
	}


	if(calc>255) calc = 255;
	else if(calc<0) calc = 0;

	return integerToString(calc);
}

String calc_color_string(String type){
	return integerToString(calc_color_int(type));
}

updateColor(){
	genColor.setXmlParam("color", calc_color_string("RED")+","+calc_color_string("GREEN")+","+calc_color_string("BLUE"));
	genColor.setXmlParam("tooltip", "Generated color ("+genColor.getXmlParam("color")+")");
}

genSliders.onLeftClick(){
	if(hslmode.isChecked()) rgbButton.leftClick();

	r_slider.setPosition(4096+calc_gamma(stringToInteger(sourceRed.getText()), stringToInteger(reqRed.getText())));
	g_slider.setPosition(4096+calc_gamma(stringToInteger(sourceGreen.getText()), stringToInteger(reqGreen.getText())));
	b_slider.setPosition(4096+calc_gamma(stringToInteger(sourceBlue.getText()), stringToInteger(reqBlue.getText())));

	applyChanges.leftClick();
}